﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.3
@EndOfDesignText@
#Event: Finished

Sub Class_Globals
	 
	 Public ItemMod As Int = 0
	 Public iPath As String 
	 Public iFileList As String
	 
	 Public mChosenMap As Map  ' map of saved filenames and paths
	
	Private TitleHeight As Int = 50dip
	Private Txtsize As Int = 34

	Private scal As Double
	
	Private pnlselect As Panel
	Private clvunits As CustomListView
	Private detLabel As Label
	Private xui As XUI
	
	Private lbltitle As Label
	Private btncan As Button
	Private btnsave As Button
	
	Private iv2 As ImageView
	Private lblheadtitle As Label
	
	Private		mFilesList									As List
	Private		mDirectoriesList							As List

	Private 	mCurrentPath								As String
	Private		mWildCard									As String
	
	Private headpnl As Panel
	
	Private imgv As ImageView
	Private pnlimvg As Panel
	Private lblsel As Label
	Private lblnext As Label
	Private lblprev As Label
	Private istart As Int = 0
	Private iend As Int = 19
	Private iflsize As Int = 0
	Private w, h As Int
	
	Private pg1 As ProgressBar
	Private lbldir As Label
	Private pnldir As Panel
	
	Private dpnl As Panel
 '   Private mAct As Activity
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(act As Activity)
	
'	mAct  = act
	
	act.LoadLayout("modlist")
	pnlselect.Visible = False

	scal = GetDeviceLayoutValues.Scale   ' set text and views height base on device scale
	If scal > 2 Then
		Txtsize = 20
		TitleHeight = 40dip
	End If
	lblheadtitle.TextSize = Txtsize
	Log(" scale: "&scal&"  text size: "&Txtsize)
End Sub

Public  Sub WaitForResult As ResumableSub
		pnlimvg.Visible = False
		pnlselect.Visible = True	
	    w = imgv.Width   'save orginal imageview width and height
		h = imgv.Height

	    istart = 0  ' start at biginning of files
    
		mChosenMap.Initialize
		mFilesList.Initialize
		mDirectoriesList.Initialize		
		iPath = File.Combine( File.DirRootExternal, "DCIM/Camera")
		iFileList =  "*.png,*.jpg"

		BuildUnitList

		Do While ItemMod = 0   ' I don't like this method of waiting..... Prefer event to wait upon....
			Sleep(0)
		Loop		
			
'		Log(" waiting for loop to end")	
		ItemMod = 0	
		pnlselect.Visible = False   ' hide the main panel...
		Return mChosenMap           ' map of selected images 
			
End Sub


Public Sub BuildUnitList

	
	pnlselect.Visible = True
	
	GetFiles
	CreateDetail
	
End Sub

Public Sub GetFiles 

		clvunits.Clear
	
		If  iPath.Length > 0 Then
			If  iPath.CharAt(iPath.Length-1) = "/" Then
				iPath = iPath.SubString2(0, iPath.Length-1)
			End If
		End If
		
		mCurrentPath 	= iPath
		mWildCard	 	= iFileList
		
		ListFilesAndFolders(mCurrentPath, False, mWildCard, True, True)
End Sub


Private Sub ListFilesAndFolders(Path As String, Recursive As Boolean, WildCards As String, Sorted As Boolean, Ascending As Boolean)
			
			mFilesList.Clear
			mDirectoriesList.Clear
			
			GetDirs(Path, Recursive, WildCards, Sorted, Ascending,  True, True)
			
			If  Sorted Then
				mDirectoriesList.SortCaseInsensitive(Ascending)
			End If			
			
			If  Sorted Then
				mFilesList.SortCaseInsensitive(False)
			End If

	For i = 0 To mDirectoriesList.Size-1
'		Log(" Dir List: "&mDirectoriesList.Get(i))
	Next

	iflsize = mFilesList.Size


End Sub

Private Sub GetDirs(Path As String, Recursive As Boolean, WildCards As String, Sorted As Boolean, Ascending As Boolean, vListFiles As Boolean, vListDirs As Boolean)
			
			Dim GetCards() 	As String = Regex.Split(",", WildCards)
  			Dim mask 		As String
			Dim pattern 	As String
			'ctr = 0
			For i = 0 To GetCards.Length-1
				GetCards(i) = GetCards(i).Trim
			Next
			
  			If  File.IsDirectory("",  Path) Then
				Dim FilesFound As List = File.ListFiles( Path)						'  This line can return an Uninitialized list if Directory NOT Accessable
				
				If  FilesFound.IsInitialized = False Then FilesFound.Initialize		'  This line prevents us from crashing
				
				For i = 0 To FilesFound.Size -1
					If  File.IsDirectory(Path,FilesFound.Get(i)) Then
						If  vListDirs Then
							mDirectoriesList.Add(Path &"/" &FilesFound.Get(i))
						End If
						
						If 	Recursive Then
							GetDirs(Path &"/" &FilesFound.Get(i), Recursive, WildCards, Sorted, Ascending, vListFiles, vListDirs)
						End If
					Else
					    If 	vListFiles Then
							For l = 0 To GetCards.Length -1
			      				Dim TestItem As String = FilesFound.Get(i)
								
								mask = GetCards(l).Trim
								pattern = "^" &mask.Replace(".", "\.").Replace("*", ".+").Replace("?", ".") &"$"
								
								If  Regex.IsMatch(pattern,TestItem) = True Then
									mFilesList.Add(Path &"/" &FilesFound.Get(i))
								End If
			    			Next
						End If
					End If
				Next
			End If
End Sub



Sub CreateHead( Title As String)
	
	lbltitle.Tag = "HEAD"
	pg1.Color = xui.Color_DarkGray

	pg1.Progress =  (istart / iflsize  )  * 100
'	Log(" prog: "&pg1.Progress)

	lbltitle.Text = Title&" ("&pg1.Progress&"%)"
	lbltitle.TextSize = Txtsize+4
	
End Sub

Sub lblnext_Click

	If istart >= iflsize Then
		ToastMessageShow(" No More Images to Display",True)
		Return
	End If
	clvunits.Clear
	
    CreateDetail	
	
End Sub

Sub lblprev_Click


	
	istart = istart - (iend * 2 + 2)
'	Log(" Curr Prev: "&istart&"  end "&iend)
	If istart < 0 Then
		istart = 0
		ToastMessageShow(" No Previous Images to Display",True)
		
		Return
	End If

	clvunits.Clear
	CreateDetail
	
End Sub



Sub CreateDetail 
		
ProgressDialogShow2(" Loading List of Images...",False) 	
If iflsize > 0 Then
'	Log(" start and end "&istart&"  "&iend&"  list size "&iflsize&"  end at: "&(istart +  iend) )
	For i = istart To (istart +  iend)  'dlst.Size-1
		
		If i > iflsize-1 Then
	'		Log("bailing at: "&i)
			Exit
		End If
		
		Dim pn As B4XView = xui.CreatePanel( "dpnl1")
		
		pn.SetLayoutAnimated(0, 0dip,  0dip, clvunits.AsView.Width,   TitleHeight+30dip)
		pn.LoadLayout("fitems")
		pn.Visible = False
		Dim  FileName		As String
		Dim	 LastSlash		As Int
		detLabel.TextColor = xui.Color_Blue
		clvunits.SetColorList(dpnl,   xui.Color_RGB( 200,255,255),xui.Color_RGB( 200,255,255),xui.Color_RGB( 200,255,255), xui.Color_Green)

		If i Mod 2 = 0 Then
			clvunits.SetColorList(dpnl,   xui.Color_RGB( 255,248,220),xui.Color_RGB( 255,248,220),xui.Color_RGB( 255,248,220), xui.Color_Green)
			
		End If
        
		FileName 	= mFilesList.Get(i)
		LastSlash 	= FileName.LastIndexOf("/")
	
		If  LastSlash <> -1 Then
			FileName = FileName.SubString(LastSlash + 1)
		End If
		
		detLabel.Text =  FileName
		detLabel.TextSize = Txtsize - 2
		detLabel.Gravity = Gravity.CENTER_VERTICAL 
		detLabel.Tag = i

		Dim bm As Bitmap
	    bm.InitializeResize  (mCurrentPath, FileName, iv2.Width,iv2.Height,True )
	    iv2.Bitmap = bm
		iv2.Gravity = Gravity.CENTER
		iv2.Tag = FileName
		
		pn.Tag = FileName
		clvunits.Add(pn, "DET")
		If mChosenMap.ContainsKey(FileName) Then
			lblsel.Tag = 1
			lblsel.Text = 	Chr(0xF046) ' chk
			lblsel.TextColor = Colors.ARGB(255,34,139,34)
	    Else
			lblsel.Tag = 0
		End If
		
		Sleep(0)
        pn.Visible = True
		istart = istart + 1
	Next
	Else
		ToastMessageShow(" No images found!  Likely No Permissions to View!", True)
	End If	
	ProgressDialogHide

	CreateHead(Chr(0xF112) &" .."&mCurrentPath.SubString2( mCurrentPath.LastIndexOf("/"), mCurrentPath.Length)) '&" ("&(istart+iend)&" of "&iflsize&")")
	
End Sub


Sub CreateDirpick 

		
ProgressDialogShow2(" Loading List of Directories...",False) 	
If mDirectoriesList.Size > 0 Then
	clvunits.Clear
	
	For i = 0 To mDirectoriesList.Size-1  'dlst.Size-1
		
		Dim pn As B4XView = xui.CreatePanel("pnldir")
		pn.SetLayoutAnimated(0, 0dip,  0dip, clvunits.AsView.Width,   TitleHeight+30dip)
		pn.LoadLayout("dirs")
		pn.Visible = False
		Dim  FileName		As String
		Dim	 LastSlash		As Int
		clvunits.SetColorList(pnldir,   xui.Color_RGB( 200,255,255),xui.Color_RGB( 200,255,255),xui.Color_RGB( 200,255,255), xui.Color_Green)

		If i Mod 2 = 0 Then
			clvunits.SetColorList(pnldir,   xui.Color_RGB( 255,248,220),xui.Color_RGB( 255,248,220),xui.Color_RGB( 255,248,220), xui.Color_Green)
		End If
        
		FileName 	= mDirectoriesList.Get(i)
		LastSlash 	= FileName.LastIndexOf("/")
	
		If  LastSlash <> -1 Then
			FileName = FileName.SubString(LastSlash + 1)
		End If
		
		lbldir.Text =  FileName
		lbldir.TextSize = Txtsize - 2
		lbldir.Gravity = Gravity.CENTER_VERTICAL 
		lbldir.Tag = i

		pn.Tag = FileName
		clvunits.Add(pn, "DIR")
		Sleep(0)
        pn.Visible = True
	Next
	Else
		ToastMessageShow(" No Directories found!  Likely No Permissions to View!", True)
	End If	
	ProgressDialogHide
	CreateHead(Chr(0xF112) &" .."&mCurrentPath.SubString2( mCurrentPath.LastIndexOf("/"), mCurrentPath.Length)) '&" ("&(istart+iend)&" of "&iflsize&")")
	
End Sub



Sub iv2_click
	Dim iv As ImageView = Sender
	Dim fn As String = iv.Tag
	ShowImg(fn)
End Sub



Sub dpnl1_click
	Dim s As B4XView =  Sender
	Dim pnl As B4XView = s.GetView(0)
	
'	Log(" pnl: "&pnl.NumberOfViews)
	Dim labl As Label = pnl.GetView(2)  ' get checkmark 
	Dim fn As Label = pnl.GetView(0)    ' get filename
	
	
	If labl.Tag = 0 Then
		labl.Tag = 1
		labl.Text = 	Chr(0xF046) ' chk
		labl.TextColor = Colors.ARGB(255,34,139,34)
		UpdateSelectMap(fn.Text, labl.Tag)    ' set selected map

	Else If labl.Tag = 1 Then
		labl.Tag = 0
		labl.Text = 	Chr(0xF057) ' x
		labl.TextColor = Colors.Red
		UpdateSelectMap(fn.Text, labl.Tag) 

	End If
	
	
End Sub

Sub UpdateSelectMap(fn As String, tg As Int)
	
	If tg = 1 Then
		mChosenMap.Put(fn,mCurrentPath) ' add to map
	Else
		mChosenMap.Remove(fn)	' remove from map if exists
	End If

	
End Sub


Sub Activity_Resume
	
	 
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub ShowImg(fn As String)
	
	imgv.Height = h
	imgv.Width = w
'	Log(" Image: Original Width: "&imgv.Width&"  Height: "&imgv.Height)
	
	Dim bm As Bitmap
	
	bm.InitializeResize  (mCurrentPath, fn, w, h, True )
	imgv.Height = bm.Height
	imgv.Width = bm.Width
	
	If GetDeviceLayoutValues.Height > GetDeviceLayoutValues.Width Then
		imgv.Top =  pnlimvg.Height / 4 
		'Log(" port")
	Else
		imgv.Left = imgv.Width / 8
		'Log(" land")
	
	End If
	
	imgv.Bitmap = bm
    pnlimvg.Visible = True	
	'Log(" Image: Now Width: "&imgv.Width&"  Height: "&imgv.Height)
	pnlimvg.BringToFront
	
	
End Sub

Sub pnlselect_Touch (Action As Int, X As Float, Y As Float)
	' do nothing - eat touch
End Sub


Sub btnsave_Click

	ItemMod = 1
	pnlselect.Visible = False
	
End Sub

Sub btncan_Click
    Dim numf As Int = mChosenMap.Size 
	
	If numf > 0 Then
	    Dim res As Int
		res = Msgbox2( "You Have "&numf& " File(s) Selected"&CRLF&"Cancel Anyway? ", "Wait!" ,"Yes","No","",Null)
		If res = DialogResponse.POSITIVE Then
			pnlselect.Visible = False
		End If
	Else
			pnlselect.Visible = False
	End If
	
End Sub


Sub imgv_Click
  pnlimvg.Visible = False
End Sub

Sub pnlimvg_Click
  pnlimvg.Visible = False
End Sub




Sub headpnl_Click
	
    Dim numf As Int = mChosenMap.Size 
	
	If numf > 0 Then
	    Dim res As Int
		res = Msgbox2( "You Have "&numf& " File(s) Selected"&CRLF&"Selection Will Be Lost..."&CRLF&"Continue Anyway? ", "Wait!" ,"Yes","No","",Null)
		If res = DialogResponse.POSITIVE Then
			' do nothing
		Else
			Return	
		End If
	End If
	
	
	mChosenMap.Initialize
	
'	Log("head panel: "&Sender)
'	Dim pnl As B4XView = Sender
'	Dim DirLabel As Label = pnl.GetView(0)
'	Log("FP_Directory:" &DirLabel.Text)
	

	Dim  LastSlash 	As Int = mCurrentPath.LastIndexOf("/")
	Dim	 TempPath	As String
	
	If  LastSlash = -1 Then Return
	
	
	TempPath = mCurrentPath.SubString2(0, LastSlash)
	
	If  TempPath.Contains("/") = False Then Return
	
	mCurrentPath = TempPath
'	Log("dotdotclick: "&mCurrentPath)
	
    ListFilesAndFolders(mCurrentPath, False, mWildCard, True, True)	
	
	CreateDirpick
	
End Sub

Sub pnldir_Click
	
	
	
	Dim v As B4XView = Sender
	Dim l As Label = v.GetView(0)

	mCurrentPath = mCurrentPath& "/"&l.Text
	
	iPath = mCurrentPath 
'	Log(" Clicked dir currpath "&mCurrentPath)
'	Log(" Clicked dir ipath "&mCurrentPath)
    istart = 0
	
	GetFiles

	CreateHead(Chr(0xF112) &" .."&mCurrentPath.SubString2( mCurrentPath.LastIndexOf("/"), mCurrentPath.Length)) '&" (folder) ")
	
	If mFilesList.Size > 0 Then
		CreateDetail
	Else
		CreateDirpick
		
	End If	
	
	
End Sub

Sub lbldir_Click

	Dim l As Label = Sender

	mCurrentPath = mCurrentPath& "/"&l.Text
	iPath = mCurrentPath 
    istart = 0

	GetFiles

	CreateHead(Chr(0xF112) &" .."&mCurrentPath.SubString2( mCurrentPath.LastIndexOf("/"), mCurrentPath.Length)) '&" (folder) ")
	If mFilesList.Size > 0 Then
		CreateDetail
	Else
		CreateDirpick
	End If	
	
End Sub
